<?php
/*******************************************************************************
PkLasku : web-based invoicing software.
Copyright (C) 2004-2008 Samu Reinikainen

This program is free software. See attached LICENSE.

*******************************************************************************/

/*******************************************************************************
PkLasku : web-pohjainen laskutusohjelmisto.
Copyright (C) 2004-2008 Samu Reinikainen

Tm ohjelma on vapaa. Lue oheinen LICENSE.

*******************************************************************************/

/***********************************************************************
 list_switch.php
 
 provides switches for different lists
 
***********************************************************************/

switch ( $strForm ) {

case 'company':
   $strTable = _DB_PREFIX_. "_company";
   $astrSearchFields = 
    array( 
        array("name" => "company_name", "type" => "TEXT"),
        array("name" => "company_id", "type" => "TEXT")
    );
   $astrHiddenSearchField = array("name" => "type_id", "type" => "INT");
   $strPrimaryKey = "id";
   $astrShowFields = 
    array( 
        array("name" => "company_name", "type" => "TEXT"),
        array("name" => "company_id", "type" => "TEXT")
    );
   $strMainForm = "form.php?ses=".$GLOBALS['sesID']."&selectform=company";
   $strTitle = $GLOBALS['locCOMPANIES'];
break;

case 'invoice':
   $strTable = _DB_PREFIX_. "_invoice";
   $astrSearchFields = 
    array(
        array("name" => "invoice_no", "type" => "TEXT"),
        array("name" => "ref_number", "type" => "TEXT"),
        array("name" => "name", "type" => "TEXT")
    );
   $strPrimaryKey = "id";
   $astrShowFields = 
    array( 
        array("name" => "invoice_date", "type" => "INTDATE", "order" => "DESC"),
        //array("name" => "real_invoice_no", "type" => "INT", "order" => "DESC"),
        array("name" => "invoice_no", "type" => "TEXT"),
        array("name" => "name", "type" => "TEXT")
    );
   $strMainForm = "form.php?ses=".$GLOBALS['sesID']."&selectform=invoice";
   $strTitle = $GLOBALS['locINVOICES'];
   
break;
/***********************************************************************
    END SEARCH LISTS - HAKU
***********************************************************************/

/***********************************************************************
    SYSTEM LISTS - JRJESTELM
***********************************************************************/
case 'base_info':
   $strTable = "". _DB_PREFIX_. "_base";
   $astrSearchFields = 
    array( 
        array("name" => "name", "type" => "TEXT")
    );
   $strPrimaryKey = "id";
   $astrShowFields = 
    array( 
        array("name" => "name", "type" => "TEXT")
    );
    //array('name');
   $strMainForm = "form.php?ses=".$GLOBALS['sesID']."&selectform=base_info";
   $strTitle = $GLOBALS['locBASEINFO'];
break;

case 'invoice_state':
   $strTable = "". _DB_PREFIX_. "_invoice_state";
   $astrSearchFields = 
    array( 
        array("name" => "name'", "type" => "TEXT")
    );
   $strPrimaryKey = "id";
   $astrShowFields = 
    array( 
        array("name" => "order_no", "type" => "TEXT"),
        array("name" => "name", "type" => "TEXT")
    );
    //array('order_no','name');
   $strMainForm = "form.php?ses=".$GLOBALS['sesID']."&selectform=invoice_state";
   $strTitle = $GLOBALS['locINVOICESTATES'];
break;
   
case 'row_type':
   $strTable = "". _DB_PREFIX_. "_row_type";
   $astrSearchFields = 
    array( 
        array("name" => "name", "type" => "TEXT")
    );
   $strPrimaryKey = "id";
   $astrShowFields = 
    array( 
        array("name" => "order_no", "type" => "TEXT"),
        array("name" => "name", "type" => "TEXT")
    );
    //array('order_no','name');
   $strMainForm = "form.php?ses=".$GLOBALS['sesID']."&selectform=row_type";
   $strTitle = $GLOBALS['locROWTYPES'];
break;

case 'company_type':
   $strTable = "". _DB_PREFIX_. "_company_type";
   $astrSearchFields = 
    array( 
        array("name" => "name", "type" => "TEXT")
    );
   $strPrimaryKey = "id";
   $astrShowFields = 
    array( 
        array("name" => "order_no", "type" => "TEXT"),
        array("name" => "name", "type" => "TEXT")
    );
    //array('order_no','name');
   $strMainForm = "form.php?ses=".$GLOBALS['sesID']."&selectform=company_type";
   $strTitle = $GLOBALS['locCOMPANYTYPES'];
break;
   
case 'session_type':
   $strTable = "". _DB_PREFIX_. "_session_type";
   $astrSearchFields = 
    array( 
        array("name" => "name", "type" => "TEXT")
    );
   $strPrimaryKey = "id";
   $astrShowFields = 
    array( 
        array("name" => "order_no", "type" => "TEXT"),
        array("name" => "name", "type" => "TEXT")
    );
    //array('order_no','name');
   $strMainForm = "form.php?ses=".$GLOBALS['sesID']."&selectform=session_type";
   $strTitle = $GLOBALS['locSESSIONTYPES'];
break;
   
case 'users':
   $strTable = "". _DB_PREFIX_. "_users";
   $astrSearchFields = 
    array( 
        array("name" => "name", "type" => "TEXT")
    );
   $strPrimaryKey = "id";
   $astrShowFields = 
    array( 
        array("name" => "name", "type" => "TEXT")
    );
    //array('name');
   $strMainForm = "form.php?ses=".$GLOBALS['sesID']."&selectform=users";
   $strTitle = $GLOBALS['locUSERS'];
break;

/***********************************************************************
    END SYSTEM LISTS - JRJESTELM
***********************************************************************/

default :
    echo "What would you like me to do?"; die;
    break;
}

?>
