<?php
/*******************************************************************************
PkLasku : web-based invoicing software.
Copyright (C) 2004-2008 Samu Reinikainen

This program is free software. See attached LICENSE.

*******************************************************************************/

/*******************************************************************************
PkLasku : web-pohjainen laskutusohjelmisto.
Copyright (C) 2004-2008 Samu Reinikainen

Tm ohjelma on vapaa. Lue oheinen LICENSE.

*******************************************************************************/

require "htmlfuncs.php";
require "sqlfuncs.php";
require "sessionfuncs.php";

$strSesID = $_REQUEST['ses'] ? $_REQUEST['ses'] : FALSE;

if( !sesCheckSession( $strSesID ) ) {
    die;
}
require "localize.php";

echo htmlPageStart( _PAGE_TITLE_ );

$blnShowSearch = $_REQUEST['search'] ? TRUE : FALSE;
$strFormSwitch = $_REQUEST['selectform'] ? $_REQUEST['selectform'] : FALSE;
$blnShowAdmin = $_REQUEST['admin'] ? TRUE : FALSE;
$blnShowSettings = $_REQUEST['settings'] ? TRUE : FALSE;
$blnShowSettings2 = $_REQUEST['settings2'] ? TRUE : FALSE;
$blnShowSettings3 = $_REQUEST['settings3'] ? TRUE : FALSE;
$blnShowSystem = $_REQUEST['system'] ? TRUE : FALSE;
$blnShowInv = $_REQUEST['invoice'] ? TRUE : FALSE;
$blnShowReport = $_REQUEST['reports'] ? TRUE : FALSE;
$blnShowPrintForm = $_REQUEST['print_form'] ? TRUE : FALSE;

$strShow = $_REQUEST['show'] ? $_REQUEST['show'] : "invoice";

$strOpenForm = "blank.html";

if( $strFormSwitch ) {
    $strQuery = 
        "SELECT id, name FROM ". _DB_PREFIX_. "_location ".
        "WHERE name = '". $strFormSwitch. "'";
    $intRes = mysql_query($strQuery);
    $intNRes = mysql_numrows($intRes);
    if( $intNRes ) {
        $intcategoryID = mysql_result($intRes, 0, "id");
        $strLabel = mysql_result($intRes, 0, "name");
        $strHiddenTerm = "<input type=\"hidden\" name=\"category_id\" value=\"". $intcategoryID."\">";
        $strExtSearchTerm = "&catid=". $intcategoryID;
    }
}
else {
    $intcategoryID = FALSE;
    $strLabel = $GLOBALS['locALLLOCATIONS'];
    $strExtSearchTerm = "";
}

switch ( $strShow ) {
    
case "system" :
    $strLabel = $GLOBALS['locSHOWSYSTEMNAVI'];
    $astrNaviLinks = 
    array( 
        array("href" => "list.php?ses=".$GLOBALS['sesID']."&selectform=session_type", "text" => $GLOBALS['locSESSIONTYPES'], "target" => "f_list", "levels_allowed" => array(99)),
        array("href" => "list.php?ses=".$GLOBALS['sesID']."&selectform=users", "text" => $GLOBALS['locUSERS'], "target" => "f_list", "levels_allowed" => array(99))
    );
break;
case "settings" :
    $strLabel = $GLOBALS['locSHOWSETTINGSNAVI'];
    $astrNaviLinks = 
    array( 
        array("href" => "list.php?ses=".$GLOBALS['sesID']."&selectform=base_info", "text" => $GLOBALS['locBASEINFO'], "target" => "f_list", "levels_allowed" => array(1)),
        array("href" => "list.php?ses=".$GLOBALS['sesID']."&selectform=company_type", "text" => $GLOBALS['locCOMPANYTYPES'], "target" => "f_list", "levels_allowed" => array(1)),
        array("href" => "list.php?ses=".$GLOBALS['sesID']."&selectform=invoice_state", "text" => $GLOBALS['locINVOICESTATES'], "target" => "f_list", "levels_allowed" => array(1)),
        array("href" => "list.php?ses=".$GLOBALS['sesID']."&selectform=row_type", "text" => $GLOBALS['locROWTYPES'], "target" => "f_list", "levels_allowed" => array(1)),
        
    );
break;

case "reports" :
    $strLabel = $GLOBALS['locSHOWREPORTNAVI'];
    $astrNaviLinks = 
    array( 
        array("href" => "select_invoice.php?ses=".$GLOBALS['sesID']. "&type=report", "text" => $GLOBALS['locINVOICEREPORTS'], "target" => "f_list", "levels_allowed" => array(1))
    );
break;

default :
    $blnShowSearch = TRUE;
    $strOpenForm = "open_invoices.php?ses={$GLOBALS['sesID']}";
    $strFormName = "invoice";
    $strFormSwitch = "invoice";
    $strLabel = "Nyt";
    $astrListValues = array('invoice', 'company');
    $astrListOptions = array($GLOBALS['locINVOICES'], $GLOBALS['locCOMPANIES']);
    $strListBox = htmlListBox( "selectform", $astrListValues, $astrListOptions, FALSE, "", FALSE, FALSE ); 
    $astrNaviLinks = 
    array( 
        /*array("href" => "select_invoice.php?ses=".$GLOBALS['sesID']. "&type=payment", "text" => $GLOBALS['locADDPAYMENT'], "target" => "f_list", "levels_allowed" => array(1))*/
    );
    $strInvButton = "<a class=\"actionlink\" href=\"#\" onclick=\"parent.frset_bottom.frset_main.f_main.location.href = 'form.php?ses={$GLOBALS['sesID']}&selectform=invoice&new=1'; parent.frset_bottom.f_list.location.href = 'list.php?ses={$GLOBALS['sesID']}&selectform=invoice'; return false;\">Uusi lasku</a>";
    
    $strClientButton = "<a class=\"actionlink\" href=\"#\" onclick=\"parent.frset_bottom.frset_main.f_main.location.href = 'form.php?ses={$GLOBALS['sesID']}&selectform=company&new=1'; parent.frset_bottom.f_list.location.href = 'list.php?ses={$GLOBALS['sesID']}&selectform=company'; return false;\">Uusi asiakas</a>";
    
break;
}
//$strOpenForm = "blank.html";

?>
<body class="navi" onload="changeNavi();">
<script type="text/javascript">
<!--
function changeNavi() {
//    if( this.document.form_search.changed.value == 0 || confirm('All changes will be lost!\n\rOK to continue?') ) {
        //self.location.href = strLink;
        parent.frset_bottom.f_list.location.href = '<?php echo $strOpenForm?>';
        parent.frset_bottom.frset_main.f_main.location.href = 'blank.html';
        parent.frset_bottom.frset_main.f_funcs.location.href = 'blank.html';
        parent.frset_bottom.frset_main.f_funcs2.location.href = 'blank.html';
//    }
    
    return true;
}

function openHelpWindow(event) {
    x = event.screenX;
    y = event.screenY;
    strLink = 'help.php?ses=<?php echo $GLOBALS['sesID']?>&topic=search'; window.open(strLink, '_blank', 'height=400,width=400,screenX=' + x + ',screenY=' + y + ',left=' + x + ',top=' + y + ',menubar=no,scrollbars=yes,status=no,toolbar=no');
    
    return true;
}
function openSearchWindow(mode, event) {
    x = event.screenX;
    y = event.screenY;
    if( mode == 'ext' ) {
        strLink = 'ext_search.php?ses=<?php echo $GLOBALS['sesID']?>' + '&selectform=' + this.document.form_search.selectform.options[this.document.form_search.selectform.selectedIndex].value;
        strLink = strLink + '<?php echo $strExtSearchTerm?>';
        height = '400';
        width = '500';
        windowname = 'ext';
    }
    if( mode == 'quick' ) {
        strLink = 'quick_search.php?ses=<?php echo $GLOBALS['sesID']?>';
        height = '400';
        width = '250';
        windowname = 'quicksearch';
    }

    window.open(strLink, windowname, 'height='+height+',width='+width+',screenX=' + x + ',screenY=' + y + ',left=' + x + ',top=' + y + ',menubar=no,scrollbars=yes,status=no,toolbar=no');
    
    return true;
}
-->
</script>
<form method="post" action="list.php?ses=<?php echo $GLOBALS['sesID']?>" target="f_list" name="form_search">
<table>
    <tr>
    
    <td>
        <b><?php echo $strLabel?> : </b>
    </td>
<?php
if( $blnShowSearch ) {
        
?>

    <td>
        <input type="hidden" name="changed" value="0">
        <input type="hidden" name="formswitch" value="<?php echo $strSubSelection?>">
        <?php echo $strHiddenTerm?>
        <?php echo $strListBox?>
    </td>
    <td>
        <input type="text" class="small" name="searchterms" value="" title="<?php echo $GLOBALS['locENTERTERMS']?>">
    </td>
    <td>
        <a class="actionlink" href="#" onClick="self.document.forms[0].submit();"><?php echo $GLOBALS['locSEARCH']?></a>
    </td>
    <td>
        <?php echo $strInvButton?>
    </td>
    <td>
        <?php echo $strClientButton?>
    </td>
    <td>
        <a class="buttonlink" href="#" onClick="openSearchWindow('ext',event); return false;"><?php echo $GLOBALS['locEXTSEARCH']?></a>
    </td>
    <td>
        <a class="buttonlink" href="#" onClick="openSearchWindow('quick',event); return false;"><?php echo $GLOBALS['locQUICKSEARCH']?></a>
    </td>
    <td>
        <a class="buttonlink" href="#" onClick="openHelpWindow(event); return false;"><?php echo $GLOBALS['locHELP']?></a>
    </td>
<?
}

    for( $i = 0; $i < count($astrNaviLinks); $i++ ) {
        if( in_array($GLOBALS['sesACCESSLEVEL'], $astrNaviLinks[$i]["levels_allowed"]) || $GLOBALS['sesACCESSLEVEL'] == 99 ) {
            if( $astrNaviLinks[$i]['target'] == "_self" ) {
?>    
     <td>
        <a class="buttonlink" href="#"  onClick="self.location.href = '<?php echo $astrNaviLinks[$i]['href']?>'; parent.frset_bottom.frset_main.f_main.location.href = 'blank.html'; parent.frset_bottom.frset_main.f_funcs.location.href = 'blank.html'; parent.frset_bottom.frset_main.f_funcs2.location.href = 'blank.html'; return false;"><?php echo $astrNaviLinks[$i]['text']?></a>
     </td>
<?php            
            }
            else {
?>    
     <td>
        <a class="buttonlink" href="#"  onClick="parent.frset_bottom.f_list.location.href = '<?php echo $astrNaviLinks[$i]['href']?>'; parent.frset_bottom.frset_main.f_main.location.href = 'blank.html'; parent.frset_bottom.frset_main.f_funcs.location.href = 'blank.html'; parent.frset_bottom.frset_main.f_funcs2.location.href = 'blank.html'; return false;"><?php echo $astrNaviLinks[$i]['text']?></a>
     </td>
<?php
            }
        }
    }
?>

</tr>
</table>
</form>

</body>
</html>
